Imports System.Web.Http
Imports Breeze.ContextProvider
Imports Breeze.ContextProvider.EF6
Imports Breeze.WebApi2
Imports DataAccess
Imports DomainTypes
Imports Newtonsoft.Json.Linq

Namespace April2014SampleWebForms
  <BreezeController>
  Public Class BreezeController
	  Inherits ApiController

	Private ReadOnly _contextProvider As New EFContextProvider(Of FunStuffTrackerContext)

	<HttpGet>
	Public Function Metadata() As String
	  Return _contextProvider.Metadata
	End Function

	<HttpGet>
	Public Function Comments(Optional ByVal userId As Integer = 0) As IQueryable(Of FunStuffComment)
		 Return _contextProvider.Context.Comments.Where(Function(c) c.UserId = userId)

#If false Then 'processor is not necessary since code is unreachable, but there to be clear
	  'temporary for in-memory data
	  Select Case userId
		Case 1 'temporary for in-memory data
	  Return New List(Of FunStuffComment) From {
		  New FunStuffComment With {.FunStuffName = "Bike Ride", .Comment = "Can't wait for spring!", .FunStuffId = 1, .UserId = 1},
		  New FunStuffComment With {.FunStuffName = "Play in Snow", .Comment = "Will we ever get snow?", .FunStuffId = 2, .UserId = 1},
		  New FunStuffComment With {.FunStuffName = "Ski", .Comment = "Also depends on that snow", .FunStuffId = 3, .UserId = 1}}.AsQueryable

		Case 2
		  Return New List(Of FunStuffComment) From {
			  New FunStuffComment With {.FunStuffName = "Watch Animal Planet", .Comment = "Especially when they run across the screen", .FunStuffId = 1, .UserId = 2},
			  New FunStuffComment With {.FunStuffName = "Play in Snow", .Comment = "Even better with my mommy", .FunStuffId = 2, .UserId = 2}}.AsQueryable
		Case Else
		  Return New List(Of FunStuffComment).AsQueryable
	  End Select
#End If

	End Function

	<HttpPost>
	Public Function SaveChanges(ByVal saveBundle As JObject) As SaveResult
	  Return _contextProvider.SaveChanges(saveBundle)
	End Function
  End Class
End Namespace
