Imports System.Data.Entity
Imports DataAccess
Imports DomainTypes

Namespace April2014SampleWebForms
	Public Class DataRepository
		Implements IDisposable

		Public Function GetUserById(ByVal id As Integer) As User
			Using ctx = New FunStuffTrackerContext
				Return ctx.Users.Find(id)
			End Using
		End Function

		Public Function GetFunStuffList() As List(Of FunStuff)
			Using ctx = New FunStuffTrackerContext
				Return ctx.FunStuffs.OrderBy(Function(f) f.Description).AsNoTracking.ToList
			End Using
		End Function

		Public Sub UpdateFunStuffForUser(ByVal selectedItemsListFromChecks As IList(Of Integer), ByVal userId As Integer)
			Using ctx = New FunStuffTrackerContext
				Dim user = ctx.Users.Find(userId)
				user.PopulateFunStuffList(selectedItemsListFromChecks)
				user.ConcantenateFunStuff()
				ctx.SaveChanges()
			End Using
		End Sub

		Public Function GetUserRefList() As List(Of RefList)
			Using ctx = New FunStuffTrackerContext
				Return ctx.Users.OrderBy(Function(u) u.LastName).Select(Function(u) New RefList With {.Name = u.FirstName & " " & u.LastName, .Id = u.Id}).ToList
			End Using
		End Function

		Public Class RefList
			Public Property Id As Integer

			Public Property Name As String
		End Class

		Public Sub Dispose() Implements IDisposable.Dispose
		End Sub
	End Class
End Namespace
