Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports DomainTypes

Namespace April2014SampleWebForms
	Partial Public Class FunStuffForm
		Inherits Page

		Private repo As DataRepository

		Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
			repo = New DataRepository
			If Not IsPostBack Then
				chkListStuff.DataSource = repo.GetFunStuffList
				chkListStuff.DataValueField = "Id"
				chkListStuff.DataTextField = "Description"
				chkListStuff.DataBind()

				lstUsers.DataSource = repo.GetUserRefList
				lstUsers.DataValueField = "Id"
				lstUsers.DataTextField = "Name"
				lstUsers.DataBind()
				GetUser()
			End If
		  '  UpdateChecksMarkup();
		End Sub

		Private Sub GetUser()
			Dim user = repo.GetUserById(Integer.Parse(lstUsers.SelectedValue))
			hiddenId.Value = user.Id.ToString
			SelectChecksFromFunStuffList(user.GetFunStuffList)
		End Sub

		'private void UpdateChecksMarkup()
		'{
		'    foreach (ListItem item in chkListStuff.Items)
		'    {
		'        item.Attributes.Add("data-label", item.Text);
		'    }
		'}

		Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs)
			 Dim id As Integer
			'parse will only fail if someone mucks with the html at runtime, real app will protect, handle issues, etc.
			If Integer.TryParse(hiddenId.Value, id) Then
				repo.UpdateFunStuffForUser(SelectedItemsListFromChecks, id)
			End If
		End Sub

		Private Function SelectedItemsListFromChecks() As List(Of Integer)
			Return chkListStuff.Items.OfType(Of ListItem)().Where(Function(i) i.Selected).Select(Function(item) Integer.Parse(item.Value)).ToList
		End Function

		Private Sub SelectChecksFromFunStuffList(ByVal stuffList As IEnumerable(Of Integer))
			chkListStuff.ClearSelection()

			For Each item As Integer In stuffList
				Dim chkItem As ListItem = chkListStuff.Items.FindByValue(item.ToString)
				If chkItem IsNot Nothing Then
					chkItem.Selected = True
				End If
			Next item
		End Sub

		Protected Sub lstUsers_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
			GetUser()
		End Sub
	End Class
End Namespace
