Imports System.Data.Entity
Imports DomainTypes

Namespace DataAccess
	Public Class FunStuffTrackerContext
		Inherits DbContext

		Public Property Users As DbSet(Of User)

		Public Property FunStuffs As DbSet(Of FunStuff)

		Public Property Comments As DbSet(Of FunStuffComment)
	End Class

	Public Class FunStuffDbInit
		Inherits DropCreateDatabaseIfModelChanges(Of FunStuffTrackerContext)

		Protected Overrides Sub Seed(ByVal context As FunStuffTrackerContext)
			Dim stuffList = New List(Of FunStuff) From {
				New FunStuff With {.Description = "Bike Ride"},
				New FunStuff With {.Description = "Ski"},
				New FunStuff With {.Description = "Play in Snow"},
				New FunStuff With {.Description = "Watch Doctor Who"},
				New FunStuff With {.Description = "Watch Animal Planet"},
				New FunStuff With {.Description = "Get Stuck in Airports"},
				New FunStuff With {.Description = "Dental Appt"},
				New FunStuff With {.Description = "Sunday Night Football"}}
			Dim user = New User With {.FirstName = "Julie", .LastName = "Lerman"}
			user.PopulateFunStuffList( { 1, 2, 3 })
			Dim user2 = New User With {.FirstName = "Samspon", .LastName = "Lerman"}
			user2.PopulateFunStuffList({ 4, 5, 6 })
			Dim users = New List(Of User) From {user, user2}
            users.ForEach(Sub(u) u.ConcantenateFunStuff())
			context.Users.AddRange(users)

			context.Comments.AddRange(New List(Of FunStuffComment) From {
				New FunStuffComment With {.FunStuffName = "Bike Ride", .Comment = "Can't wait for spring!", .FunStuffId = 1, .UserId = 1},
				New FunStuffComment With {.FunStuffName = "Play in Snow", .Comment = "Will we ever get snow?", .FunStuffId = 2, .UserId = 1},
				New FunStuffComment With {.FunStuffName = "Ski", .Comment = "Also depends on that snow", .FunStuffId = 3, .UserId = 1},
				New FunStuffComment With {.FunStuffName = "Watch Animal Planet", .Comment = "Especially when they run across the screen", .FunStuffId = 1, .UserId = 2},
				New FunStuffComment With {.FunStuffName = "Play in Snow", .Comment = "Even better with my mommy", .FunStuffId = 2, .UserId = 2}})

			context.FunStuffs.AddRange(stuffList)
			MyBase.Seed(context)
		End Sub
	End Class
End Namespace
